Subject: Re: SO_TIMESTAMPING fix and design decisions

From: Christopher Zimmermann <[email-masked]>
Date: Sun, 20 Sep 2009 20:50:47 +0200

On Sun, 20 Sep 2009 10:48:13 -0700
Peter P Waskiewicz Jr <[email-masked]> wrote:

> On Sun, 2009-09-20 at 00:52 -0700, Christopher Zimmermann wrote:
> > On Sat, 19 Sep 2009 15:09:21 -0700
> > Peter P Waskiewicz Jr <[email-masked]> wrote:
> > 
> > > > hardware timestamps only work for the Intel igb driver. I have 
> > > > access to two test machines with NICs supported by this driver.
> > > 
> > > Intel's 82599, supported by ixgbe, also has the same IEEE 1588
> > > timestamping support in hardware.  We haven't implemented the support
> > > yet in ixgbe, but the hardware is there and does work.  If you were
> > > curious of the interface, the datasheet for the hardware is available on
> > > our SourceForge site (e1000.sf.net).
> > 
> > hi! thanks for the reply.
> > 
> > I already got the documentation for the 82576 cards I have access to. I 
> > won't be able to afford another pair.
> > 
> > What do you think about my idea to expose the relevant registers to 
> > userspace? I believe it would not be too difficult for userspace to 
> > configure the timestamps this way and would allow way more flexibility. 
> > Of course I would #DEFINE the constants used to set the registers.
> 
> The patch seems reasonable, but I haven't played with the igb
> timestamping very much.  However, what impact will this have on the
> existing ptpd userspace daemon?

It will need to be modified. If you want to avoid this, one could keep 
the HWTSTAMP_FILTER_PTP_.... defines and just redifine them to reflect 
the new interface.
Where can I find this ptpd userspace daemon, which supports hardware 
timestamps using the ioctl interface? ptpd.sourceforge.net doesn't.

Cheers,

Christopher Zimmermann